<!---
  Licensed to the Apache Software Foundation (ASF) under one
  or more contributor license agreements.  See the NOTICE file
  distributed with this work for additional information
  regarding copyright ownership.  The ASF licenses this file
  to you under the Apache License, Version 2.0 (the
  "License"); you may not use this file except in compliance
  with the License.  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing,
  software distributed under the License is distributed on an
  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  KIND, either express or implied.  See the License for the
  specific language governing permissions and limitations
  under the License.
-->

# Arrow

[![docs](https://img.shields.io/badge/docs-latest-blue&logo=julia)](https://arrow.apache.org/julia/)
[![CI](https://github.com/apache/arrow-julia/workflows/CI/badge.svg)](https://github.com/apache/arrow-julia/actions?query=workflow%3ACI)
[![codecov](https://app.codecov.io/gh/apache/arrow-julia/branch/main/graph/badge.svg)](https://app.codecov.io/gh/apache/arrow-julia)

[![deps](https://juliahub.com/docs/Arrow/deps.svg)](https://juliahub.com/ui/Packages/Arrow/QnF3w?t=2)
[![version](https://juliahub.com/docs/Arrow/version.svg)](https://juliahub.com/ui/Packages/Arrow/QnF3w)
[![pkgeval](https://juliahub.com/docs/Arrow/pkgeval.svg)](https://juliahub.com/ui/Packages/Arrow/QnF3w)

This is a pure Julia implementation of the [Apache Arrow](https://arrow.apache.org) data standard.  This package provides Julia `AbstractVector` objects for
referencing data that conforms to the Arrow standard.  This allows users to seamlessly interface Arrow formatted data with a great deal of existing Julia code.

Please see this [document](https://arrow.apache.org/docs/format/Columnar.html#physical-memory-layout) for a description of the Arrow memory layout.

## Installation

The package can be installed by typing in the following in a Julia REPL:

```julia
julia> using Pkg; Pkg.add("Arrow")
```

## Local Development

When developing on Arrow.jl it is recommended that you run the following to ensure that any
changes to ArrowTypes.jl are immediately available to Arrow.jl without requiring a release:

```sh
julia --project -e 'using Pkg; Pkg.develop(path="src/ArrowTypes")'
```

## Format Support

This implementation supports the 1.0 version of the specification, including support for:
  * All primitive data types
  * All nested data types
  * Dictionary encodings and messages
  * Extension types
  * Streaming, file, record batch, and replacement and isdelta dictionary messages

It currently doesn't include support for:
  * Tensors or sparse tensors
  * Flight RPC
  * C data interface

Third-party data formats:
  * CSV, parquet and avro support via the existing [CSV.jl](https://github.com/JuliaData/CSV.jl), [Parquet.jl](https://github.com/JuliaIO/Parquet.jl) and [Avro.jl](https://github.com/JuliaData/Avro.jl) packages
  * Other Tables.jl-compatible packages automatically supported ([DataFrames.jl](https://github.com/JuliaData/DataFrames.jl), [JSONTables.jl](https://github.com/JuliaData/JSONTables.jl), [JuliaDB.jl](https://github.com/JuliaData/JuliaDB.jl), [SQLite.jl](https://github.com/JuliaDatabases/SQLite.jl), [MySQL.jl](https://github.com/JuliaDatabases/MySQL.jl), [JDBC.jl](https://github.com/JuliaDatabases/JDBC.jl), [ODBC.jl](https://github.com/JuliaDatabases/ODBC.jl), [XLSX.jl](https://github.com/felipenoris/XLSX.jl), etc.)
  * No current Julia packages support ORC

See the [full documentation](https://arrow.apache.org/julia/) for details on reading and writing arrow data.

# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

# 2-arg show: show schema and list # of metadata entries if non-zero
function Base.show(io::IO, table::Table)
    ncols = length(Tables.columnnames(table))
    print(io, "$(typeof(table)) with $(Tables.rowcount(table)) rows, $(ncols) columns,")
    meta = getmetadata(table)
    if meta !== nothing && !isempty(meta)
        print(io, " ", length(meta), " metadata entries,")
    end
    sch = Tables.schema(table)
    print(io, " and schema:\n")
    show(IOContext(io, :print_schema_header => false), sch)
    return nothing
end

# 3-arg show: show schema and show metadata entries adaptively according to `displaysize`
function Base.show(io::IO, mime::MIME"text/plain", table::Table)
    display_rows, display_cols = displaysize(io)
    ncols = length(Tables.columnnames(table))
    meta = getmetadata(table)
    if meta !== nothing
        display_rows -= 1 # decrement for metadata header line
        display_rows -= min(length(meta), 2) # decrement so we can show at least 2 lines of metadata
    end
    print(
        io,
        "$(typeof(table)) with $(Tables.rowcount(table)) rows, $(ncols) columns, and ",
    )
    sch = Tables.schema(table)
    print(io, "schema:\n")
    schema_context = IOContext(
        io,
        :print_schema_header => false,
        :displaysize => (max(display_rows, 3), display_cols),
    )
    schema_str = sprint(show, mime, sch; context=schema_context)
    print(io, schema_str)
    display_rows -= (count("\n", schema_str) + 1) # decrement for number of lines printed
    if meta !== nothing
        print(io, "\n\nwith metadata given by a ")
        show(
            IOContext(io, :displaysize => (max(display_rows, 5), display_cols)),
            mime,
            meta,
        )
    end
    return nothing
end

# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

primitive type MyInt 32 end

struct Person
    id::Int
    name::String
end

@testset "ArrowTypes" begin
    @test ArrowTypes.ArrowKind(MyInt) == ArrowTypes.PrimitiveKind()
    @test ArrowTypes.ArrowKind(Person) == ArrowTypes.StructKind()
    @test ArrowTypes.ArrowKind(Person(0, "bob")) == ArrowTypes.StructKind()

    @test ArrowTypes.ArrowType(Int) == Int
    @test ArrowTypes.ArrowType(Union{Int,Missing}) == Union{Int,Missing}
    @test ArrowTypes.ArrowType(Missing) == Missing

    @test ArrowTypes.toarrow(1) === 1

    @test ArrowTypes.arrowname(Int) == Symbol()
    @test !ArrowTypes.hasarrowname(Int)

    @test ArrowTypes.arrowmetadata(Int) == ""
    @test ArrowTypes.arrowmetadata(Union{Nothing,Int}) == ""
    @test ArrowTypes.arrowmetadata(Union{Missing,Int}) == ""

    @test ArrowTypes.JuliaType(1) === nothing
    @test ArrowTypes.JuliaType(1, Int) === nothing
    @test ArrowTypes.JuliaType(1, Int, nothing) === nothing

    @test ArrowTypes.fromarrow(Int, 1) === 1
    @test ArrowTypes.fromarrow(Person, 1, "bob") == Person(1, "bob")
    @test ArrowTypes.fromarrow(Union{Int,Missing}, missing) === missing
    @test ArrowTypes.fromarrow(Union{Int,Missing}, 1) === 1
    @test ArrowTypes.fromarrow(Union{Float64,Missing}, 1) === 1.0

    @test ArrowTypes.ArrowKind(Missing) == ArrowTypes.NullKind()
    @test ArrowTypes.ArrowKind(Nothing) == ArrowTypes.NullKind()
    @test ArrowTypes.ArrowType(Nothing) == Missing
    @test ArrowTypes.toarrow(nothing) === missing
    @test ArrowTypes.arrowname(Nothing) == ArrowTypes.NOTHING
    @test ArrowTypes.JuliaType(Val(ArrowTypes.NOTHING)) == Nothing
    @test ArrowTypes.fromarrow(Nothing, missing) === nothing

    @test ArrowTypes.ArrowKind(Int) == ArrowTypes.PrimitiveKind()
    @test ArrowTypes.ArrowKind(Float64) == ArrowTypes.PrimitiveKind()

    @test ArrowTypes.ArrowType(Char) == UInt32
    @test ArrowTypes.toarrow('1') == UInt32('1')
    @test ArrowTypes.arrowname(Char) == ArrowTypes.CHAR
    @test ArrowTypes.JuliaType(Val(ArrowTypes.CHAR)) == Char
    @test ArrowTypes.fromarrow(Char, UInt32('1')) == '1'

    @test ArrowTypes.ArrowKind(Bool) == ArrowTypes.BoolKind()

    @test ArrowTypes.ListKind() == ArrowTypes.ListKind{false}()
    @test !ArrowTypes.isstringtype(ArrowTypes.ListKind())
    @test !ArrowTypes.isstringtype(typeof(ArrowTypes.ListKind()))
    @test ArrowTypes.ArrowKind(String) == ArrowTypes.ListKind{true}()
    @test ArrowTypes.ArrowKind(Base.CodeUnits) == ArrowTypes.ListKind{true}()

    hey = collect(b"hey")
    @test ArrowTypes.fromarrow(String, pointer(hey), 3) == "hey"
    @test ArrowTypes.fromarrow(Base.CodeUnits, pointer(hey), 3) == b"hey"
    @test ArrowTypes.fromarrow(Union{Base.CodeUnits,Missing}, pointer(hey), 3) == b"hey"

    @test ArrowTypes.ArrowType(Symbol) == String
    @test ArrowTypes.toarrow(:hey) == "hey"
    @test ArrowTypes.arrowname(Symbol) == ArrowTypes.SYMBOL
    @test ArrowTypes.JuliaType(Val(ArrowTypes.SYMBOL)) == Symbol
    @test ArrowTypes.fromarrow(Symbol, pointer(hey), 3) == :hey

    @test ArrowTypes.ArrowKind(Vector{Int}) == ArrowTypes.ListKind()
    @test ArrowTypes.ArrowKind(Set{Int}) == ArrowTypes.ListKind()
    @test ArrowTypes.ArrowType(Set{Int}) == Vector{Int}
    @test typeof(ArrowTypes.toarrow(Set([1, 2, 3]))) <: Vector{Int}
    @test ArrowTypes.arrowname(Set{Int}) == ArrowTypes.SET
    @test ArrowTypes.JuliaType(Val(ArrowTypes.SET), Vector{Int}) == Set{Int}
    @test ArrowTypes.fromarrow(Set{Int}, [1, 2, 3]) == Set([1, 2, 3])

    K = ArrowTypes.ArrowKind(NTuple{3,UInt8})
    @test ArrowTypes.gettype(K) == UInt8
    @test ArrowTypes.getsize(K) == 3
    @test K == ArrowTypes.FixedSizeListKind{3,UInt8}()

    u = UUID(rand(UInt128))
    ubytes = ArrowTypes._cast(NTuple{16,UInt8}, u.value)
    @test ArrowTypes.ArrowKind(u) == ArrowTypes.FixedSizeListKind{16,UInt8}()
    @test ArrowTypes.ArrowType(UUID) == NTuple{16,UInt8}
    @test ArrowTypes.toarrow(u) == ubytes
    @test ArrowTypes.arrowname(UUID) == ArrowTypes.UUIDSYMBOL
    @test ArrowTypes.JuliaType(Val(ArrowTypes.UUIDSYMBOL)) == UUID
    @test ArrowTypes.fromarrow(UUID, ubytes) == u

    ip4 = IPv4(rand(UInt32))
    @test ArrowTypes.ArrowKind(ip4) == PrimitiveKind()
    @test ArrowTypes.ArrowType(IPv4) == UInt32
    @test ArrowTypes.toarrow(ip4) == ip4.host
    @test ArrowTypes.arrowname(IPv4) == ArrowTypes.IPV4_SYMBOL
    @test ArrowTypes.JuliaType(Val(ArrowTypes.IPV4_SYMBOL)) == IPv4
    @test ArrowTypes.fromarrow(IPv4, ip4.host) == ip4

    ip6 = IPv6(rand(UInt128))
    ip6_ubytes = ArrowTypes._cast(NTuple{16,UInt8}, ip6.host)
    @test ArrowTypes.ArrowKind(ip6) == ArrowTypes.FixedSizeListKind{16,UInt8}()
    @test ArrowTypes.ArrowType(IPv6) == NTuple{16,UInt8}
    @test ArrowTypes.toarrow(ip6) == ip6_ubytes
    @test ArrowTypes.arrowname(IPv6) == ArrowTypes.IPV6_SYMBOL
    @test ArrowTypes.JuliaType(Val(ArrowTypes.IPV6_SYMBOL)) == IPv6
    @test ArrowTypes.fromarrow(IPv6, ip6_ubytes) == ip6

    nt = (id=1, name="bob")
    @test ArrowTypes.ArrowKind(NamedTuple) == ArrowTypes.StructKind()
    @test ArrowTypes.fromarrow(typeof(nt), nt) === nt
    @test ArrowTypes.fromarrow(Person, nt) == Person(1, "bob")
    @test ArrowTypes.ArrowKind(Tuple) == ArrowTypes.StructKind()
    @test ArrowTypes.ArrowKind(Tuple{}) == ArrowTypes.StructKind()
    @test ArrowTypes.arrowname(Tuple{Int,String}) == ArrowTypes.TUPLE
    @test ArrowTypes.arrowname(Tuple{}) == ArrowTypes.TUPLE
    @test ArrowTypes.JuliaType(
        Val(ArrowTypes.TUPLE),
        NamedTuple{(Symbol("1"), Symbol("2")),Tuple{Int,String}},
    ) == Tuple{Int,String}
    @test ArrowTypes.fromarrow(Tuple{Int,String}, nt) == (1, "bob")
    @test ArrowTypes.fromarrow(Union{Missing,typeof(nt)}, nt) == nt
    # #461
    @test ArrowTypes.default(Tuple{}) == ()
    @test ArrowTypes.default(Tuple{Vararg{Int}}) == ()
    @test ArrowTypes.default(Tuple{String,Vararg{Int}}) == ("",)

    v = v"1"
    v_nt = (major=1, minor=0, patch=0, prerelease=(), build=())
    @test ArrowTypes.ArrowKind(VersionNumber) == ArrowTypes.StructKind()
    @test ArrowTypes.arrowname(VersionNumber) == ArrowTypes.VERSION_NUMBER
    @test ArrowTypes.JuliaType(Val(ArrowTypes.VERSION_NUMBER)) == VersionNumber
    @test ArrowTypes.fromarrow(typeof(v), v_nt) == v
    @test ArrowTypes.default(VersionNumber) == v"0"

    @test ArrowTypes.ArrowKind(Dict{String,Int}) == ArrowTypes.MapKind()
    @test ArrowTypes.ArrowKind(Union{String,Int}) == ArrowTypes.UnionKind()

    @test ArrowTypes.default(Int) == Int(0)
    @test ArrowTypes.default(Symbol) == Symbol()
    @test ArrowTypes.default(Char) == '\0'
    @test ArrowTypes.default(String) == ""
    @test ArrowTypes.default(Missing) === missing
    @test ArrowTypes.default(Nothing) === nothing
    @test ArrowTypes.default(Union{Int,Missing}) == Int(0)
    @test ArrowTypes.default(Union{Int,Nothing}) == Int(0)
    @test ArrowTypes.default(Union{Int,Missing,Nothing}) == Int(0)

    @test ArrowTypes.promoteunion(Int, Float64) == Float64
    @test ArrowTypes.promoteunion(Int, String) == Union{Int,String}

    @test ArrowTypes.concrete_or_concreteunion(Int)
    @test !ArrowTypes.concrete_or_concreteunion(Union{Real,String})
    @test !ArrowTypes.concrete_or_concreteunion(Any)

    @testset "ToArrow" begin
        x = ArrowTypes.ToArrow([1, 2, 3])
        @test x isa Vector{Int}
        @test x == [1, 2, 3]

        x = ArrowTypes.ToArrow([:hey, :ho])
        @test x isa ArrowTypes.ToArrow{String,Vector{Symbol}}
        @test eltype(x) == String
        @test x == ["hey", "ho"]

        x = ArrowTypes.ToArrow(Any[1, 3.14])
        @test x isa ArrowTypes.ToArrow{Float64,Vector{Any}}
        @test eltype(x) == Float64
        @test x == [1.0, 3.14]

        x = ArrowTypes.ToArrow(Any[1, 3.14, "hey"])
        @test x isa ArrowTypes.ToArrow{Union{Float64,String},Vector{Any}}
        @test eltype(x) == Union{Float64,String}
        @test x == [1.0, 3.14, "hey"]

        @testset "respect non-missing concrete type" begin
            struct DateTimeTZ
                instant::Int64
                tz::String
            end

            struct Timestamp{TZ}
                x::Int64
            end

            ArrowTypes.ArrowType(::Type{DateTimeTZ}) = Timestamp
            ArrowTypes.toarrow(x::DateTimeTZ) = Timestamp{Symbol(x.tz)}(x.instant)
            ArrowTypes.default(::Type{DateTimeTZ}) = DateTimeTZ(0, "UTC")

            T = Union{DateTimeTZ,Missing}
            @test !ArrowTypes.concrete_or_concreteunion(ArrowTypes.ArrowType(T))
            @test eltype(ArrowTypes.ToArrow(T[missing])) == Union{Timestamp{:UTC},Missing}

            # Works since `ArrowTypes.default(Any) === nothing` and
            # `ArrowTypes.toarrow(nothing) === missing`. Defining `toarrow(::Nothing) = nothing`
            # would break this test by returning `Union{Nothing,Missing}`.
            @test eltype(ArrowTypes.ToArrow(Any[missing])) == Missing
        end

        @testset "ignore non-missing abstract type" begin
            x = ArrowTypes.ToArrow(Union{Missing,Array{Int}}[missing])
            @test x isa ArrowTypes.ToArrow{Missing,Vector{Union{Missing,Array{Int64}}}}
            @test eltype(x) == Missing
            @test isequal(x, [missing])
        end
    end
end

# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

struct ArrowBlob
    bytes::Vector{UInt8}
    pos::Int
    len::Int
end

ArrowBlob(bytes::Vector{UInt8}, pos::Int, len::Nothing) =
    ArrowBlob(bytes, pos, length(bytes))

tobytes(bytes::Vector{UInt8}) = bytes
tobytes(io::IO) = Base.read(io)
tobytes(io::IOStream) = Mmap.mmap(io)
tobytes(file_path) = open(tobytes, file_path, "r")

struct BatchIterator
    bytes::Vector{UInt8}
    startpos::Int
    function BatchIterator(blob::ArrowBlob)
        bytes, pos, len = blob.bytes, blob.pos, blob.len
        if len > 24 && _startswith(bytes, pos, FILE_FORMAT_MAGIC_BYTES)
            pos += 8 # skip past magic bytes + padding
        end
        new(bytes, pos)
    end
end

"""
    Arrow.Stream(io::IO; convert::Bool=true)
    Arrow.Stream(file::String; convert::Bool=true)
    Arrow.Stream(bytes::Vector{UInt8}, pos=1, len=nothing; convert::Bool=true)
    Arrow.Stream(inputs::Vector; convert::Bool=true)

Start reading an arrow formatted table, from:
 * `io`, bytes will be read all at once via `read(io)`
 * `file`, bytes will be read via `Mmap.mmap(file)`
 * `bytes`, a byte vector directly, optionally allowing specifying the starting byte position `pos` and `len`
 * A `Vector` of any of the above, in which each input should be an IPC or arrow file and must match schema

Reads the initial schema message from the arrow stream/file, then returns an `Arrow.Stream` object
which will iterate over record batch messages, producing an [`Arrow.Table`](@ref) on each iteration.

By iterating [`Arrow.Table`](@ref), `Arrow.Stream` satisfies the `Tables.partitions` interface, and as such can
be passed to Tables.jl-compatible sink functions.

This allows iterating over extremely large "arrow tables" in chunks represented as record batches.

Supports the `convert` keyword argument which controls whether certain arrow primitive types will be
lazily converted to more friendly Julia defaults; by default, `convert=true`.
"""
mutable struct Stream
    inputs::Vector{ArrowBlob}
    inputindex::Int
    batchiterator::Union{Nothing,BatchIterator}
    names::Vector{Symbol}
    types::Vector{Type}
    schema::Union{Nothing,Meta.Schema}
    dictencodings::Lockable{Dict{Int64,DictEncoding}} # dictionary id => DictEncoding
    dictencoded::Dict{Int64,Meta.Field} # dictionary id => field
    convert::Bool
    compression::Ref{Union{Symbol,Nothing}}
end

function Stream(inputs::Vector{ArrowBlob}; convert::Bool=true)
    inputindex = 1
    batchiterator = nothing
    names = Symbol[]
    types = Type[]
    schema = nothing
    dictencodings = Lockable(Dict{Int64,DictEncoding}())
    dictencoded = Dict{Int64,Meta.Field}()
    compression = Ref{Union{Symbol,Nothing}}(nothing)
    Stream(
        inputs,
        inputindex,
        batchiterator,
        names,
        types,
        schema,
        dictencodings,
        dictencoded,
        convert,
        compression,
    )
end

function Stream(input, pos::Integer=1, len=nothing; kw...)
    b = tobytes(input)
    isempty(b) ? Stream(ArrowBlob[]; kw...) : Stream([ArrowBlob(b, pos, len)]; kw...)
end

function Stream(input::Vector{UInt8}, pos::Integer=1, len=nothing; kw...)
    b = tobytes(input)
    isempty(b) ? Stream(ArrowBlob[]; kw...) : Stream([ArrowBlob(b, pos, len)]; kw...)
end

function Stream(inputs::AbstractVector; kw...)
    blobs = ArrowBlob[]
    for x in inputs
        b = tobytes(x)
        isempty(b) && continue
        push!(blobs, ArrowBlob(b, 1, nothing))
    end
    Stream(blobs; kw...)
end

function initialize!(x::Stream)
    isempty(getfield(x, :names)) || return
    # Initialize member fields using iteration and reset state
    lastinputindex = x.inputindex
    lastbatchiterator = x.batchiterator
    iterate(x)
    x.inputindex = lastinputindex
    x.batchiterator = lastbatchiterator
    nothing
end

Tables.partitions(x::Stream) = x

function Tables.columnnames(x::Stream)
    initialize!(x)
    getfield(x, :names)
end

function Tables.schema(x::Stream)
    initialize!(x)
    Tables.Schema(Tables.columnnames(x), getfield(x, :types))
end

Base.IteratorSize(::Type{Stream}) = Base.SizeUnknown()
Base.eltype(::Type{Stream}) = Table
Base.isdone(x::Stream) = x.inputindex > length(x.inputs)

function Base.iterate(x::Stream, (pos, id)=(1, 0))
    if Base.isdone(x)
        x.inputindex = 1
        x.batchiterator = nothing
        return nothing
    end
    if isnothing(x.batchiterator)
        blob = x.inputs[x.inputindex]
        x.batchiterator = BatchIterator(blob)
        pos = x.batchiterator.startpos
    end

    columns = AbstractVector[]
    compression = nothing

    while true
        state = iterate(x.batchiterator, (pos, id))
        # check for additional inputs
        while state === nothing
            x.inputindex += 1
            if Base.isdone(x)
                x.inputindex = 1
                x.batchiterator = nothing
                return nothing
            end
            blob = x.inputs[x.inputindex]
            x.batchiterator = BatchIterator(blob)
            pos = x.batchiterator.startpos
            state = iterate(x.batchiterator, (pos, id))
        end
        batch, (pos, id) = state
        header = batch.msg.header
        if isnothing(x.schema) && !isa(header, Meta.Schema)
            throw(ArgumentError("first arrow ipc message MUST be a schema message"))
        end
        if header isa Meta.Schema
            if isnothing(x.schema)
                x.schema = header
                # assert endianness?
                # store custom_metadata?
                for (i, field) in enumerate(x.schema.fields)
                    push!(x.names, Symbol(field.name))
                    push!(
                        x.types,
                        juliaeltype(field, buildmetadata(field.custom_metadata), x.convert),
                    )
                    # recursively find any dictionaries for any fields
                    getdictionaries!(x.dictencoded, field)
                    @debug "parsed column from schema: field = $field"
                end
            elseif header != x.schema
                throw(
                    ArgumentError(
                        "mismatched schemas between different arrow batches: $(x.schema) != $header",
                    ),
                )
            end
        elseif header isa Meta.DictionaryBatch
            id = header.id
            recordbatch = header.data
            @debug "parsing dictionary batch message: id = $id, compression = $(recordbatch.compression)"
            if recordbatch.compression !== nothing
                compression = recordbatch.compression
            end
            @lock x.dictencodings begin
                dictencodings = x.dictencodings[]
                if haskey(dictencodings, id) && header.isDelta
                    # delta
                    field = x.dictencoded[id]
                    values, _, _, _ = build(
                        field,
                        field.type,
                        batch,
                        recordbatch,
                        x.dictencodings,
                        Int64(1),
                        Int64(1),
                        Int64(1),
                        x.convert,
                    )
                    dictencoding = dictencodings[id]
                    append!(dictencoding.data, values)
                    continue
                end
                # new dictencoding or replace
                field = x.dictencoded[id]
                values, _, _, _ = build(
                    field,
                    field.type,
                    batch,
                    recordbatch,
                    x.dictencodings,
                    Int64(1),
                    Int64(1),
                    Int64(1),
                    x.convert,
                )
                A = ChainedVector([values])
                S =
                    field.dictionary.indexType === nothing ? Int32 :
                    juliaeltype(field, field.dictionary.indexType, false)
                dictencodings[id] = DictEncoding{eltype(A),S,typeof(A)}(
                    id,
                    A,
                    field.dictionary.isOrdered,
                    values.metadata,
                )
            end # lock
            @debug "parsed dictionary batch message: id=$id, data=$values\n"
        elseif header isa Meta.RecordBatch
            @debug "parsing record batch message: compression = $(header.compression)"
            if header.compression !== nothing
                compression = header.compression
            end
            for vec in VectorIterator(x.schema, batch, x.dictencodings, x.convert)
                push!(columns, vec)
            end
            break
        else
            throw(ArgumentError("unsupported arrow message type: $(typeof(header))"))
        end
    end

    if compression !== nothing
        if compression.codec == Flatbuf.CompressionType.ZSTD
            x.compression[] = :zstd
        elseif compression.codec == Flatbuf.CompressionType.LZ4_FRAME
            x.compression[] = :lz4
        else
            throw(ArgumentError("unsupported compression codec: $(compression.codec)"))
        end
    end

    lookup = Dict{Symbol,AbstractVector}()
    types = Type[]
    for (nm, col) in zip(x.names, columns)
        lookup[nm] = col
        push!(types, eltype(col))
    end
    return Table(x.names, types, columns, lookup, Ref(x.schema)), (pos, id)
end

"""
    Arrow.Table(io::IO; convert::Bool=true)
    Arrow.Table(file::String; convert::Bool=true)
    Arrow.Table(bytes::Vector{UInt8}, pos=1, len=nothing; convert::Bool=true)
    Arrow.Table(inputs::Vector; convert::Bool=true)

Read an arrow formatted table, from:
 * `io`, bytes will be read all at once via `read(io)`
 * `file`, bytes will be read via `Mmap.mmap(file)`
 * `bytes`, a byte vector directly, optionally allowing specifying the starting byte position `pos` and `len`
 * A `Vector` of any of the above, in which each input should be an IPC or arrow file and must match schema

Returns a `Arrow.Table` object that allows column access via `table.col1`, `table[:col1]`, or `table[1]`.

NOTE: the columns in an `Arrow.Table` are views into the original arrow memory, and hence are not easily
modifiable (with e.g. `push!`, `append!`, etc.). To mutate arrow columns, call `copy(x)` to materialize
the arrow data as a normal Julia array.

`Arrow.Table` also satisfies the [Tables.jl](https://github.com/JuliaData/Tables.jl) interface, and so can easily be materialied via any supporting
sink function: e.g. `DataFrame(Arrow.Table(file))`, `SQLite.load!(db, "table", Arrow.Table(file))`, etc.

Supports the `convert` keyword argument which controls whether certain arrow primitive types will be
lazily converted to more friendly Julia defaults; by default, `convert=true`.
"""
struct Table <: Tables.AbstractColumns
    names::Vector{Symbol}
    types::Vector{Type}
    columns::Vector{AbstractVector}
    lookup::Dict{Symbol,AbstractVector}
    schema::Ref{Meta.Schema}
    metadata::Ref{Union{Nothing,Base.ImmutableDict{String,String}}}
end

Table() = Table(
    Symbol[],
    Type[],
    AbstractVector[],
    Dict{Symbol,AbstractVector}(),
    Ref{Meta.Schema}(),
    Ref{Union{Nothing,Base.ImmutableDict{String,String}}}(nothing),
)

function Table(names, types, columns, lookup, schema)
    m = isassigned(schema) ? buildmetadata(schema[]) : nothing
    return Table(
        names,
        types,
        columns,
        lookup,
        schema,
        Ref{Union{Nothing,Base.ImmutableDict{String,String}}}(m),
    )
end

names(t::Table) = getfield(t, :names)
types(t::Table) = getfield(t, :types)
columns(t::Table) = getfield(t, :columns)
lookup(t::Table) = getfield(t, :lookup)
schema(t::Table) = getfield(t, :schema)
metadata(t::Table) = getfield(t, :metadata)

"""
    Arrow.getmetadata(x)

If `x isa Arrow.Table` return a `Base.ImmutableDict{String,String}` representation of `x`'s
`Schema` `custom_metadata`, or `nothing` if no such metadata exists.

If `x isa Arrow.ArrowVector`, return a `Base.ImmutableDict{String,String}` representation of `x`'s
`Field` `custom_metadata`, or `nothing` if no such metadata exists.

Otherwise, return `nothing`.

See [the official Arrow documentation for more details on custom application metadata](https://arrow.apache.org/docs/format/Columnar.html#custom-application-metadata).
"""
getmetadata(t::Table) = getfield(t, :metadata)[]
getmetadata(::Any) = nothing

DataAPI.metadatasupport(::Type{Table}) = (read=true, write=false)
DataAPI.colmetadatasupport(::Type{Table}) = (read=true, write=false)

function DataAPI.metadata(t::Table, key::AbstractString; style::Bool=false)
    meta = getmetadata(t)[key]
    return style ? (meta, :default) : meta
end

function DataAPI.metadata(t::Table, key::AbstractString, default; style::Bool=false)
    meta = getmetadata(t)
    if meta !== nothing
        haskey(meta, key) && return style ? meta[key] : (meta[key], :default)
    end
    return style ? (default, :default) : default
end

function DataAPI.metadatakeys(t::Table)
    meta = getmetadata(t)
    meta === nothing && return ()
    return keys(meta)
end

function DataAPI.colmetadata(t::Table, col, key::AbstractString; style::Bool=false)
    meta = getmetadata(t[col])[key]
    return style ? (meta, :default) : meta
end

function DataAPI.colmetadata(t::Table, col, key::AbstractString, default; style::Bool=false)
    meta = getmetadata(t[col])
    if meta !== nothing
        haskey(meta, key) && return style ? (meta[key], :default) : meta[key]
    end
    return style ? (default, :default) : default
end

function DataAPI.colmetadatakeys(t::Table, col)
    meta = getmetadata(t[col])
    meta === nothing && return ()
    return keys(meta)
end

function DataAPI.colmetadatakeys(t::Table)
    return (
        col => DataAPI.colmetadatakeys(t, col) for
        col in Tables.columnnames(t) if getmetadata(t[col]) !== nothing
    )
end

Tables.istable(::Table) = true
Tables.columnaccess(::Table) = true
Tables.columns(t::Table) = Tables.CopiedColumns(t)
Tables.schema(t::Table) = Tables.Schema(names(t), types(t))
Tables.columnnames(t::Table) = names(t)
Tables.getcolumn(t::Table, i::Int) = columns(t)[i]
Tables.getcolumn(t::Table, nm::Symbol) = lookup(t)[nm]

struct TablePartitions
    table::Table
    npartitions::Int
end

function TablePartitions(table::Table)
    cols = columns(table)
    npartitions = if length(cols) == 0
        0
    elseif cols[1] isa ChainedVector
        length(cols[1].arrays)
    else
        1
    end
    return TablePartitions(table, npartitions)
end

function Base.iterate(tp::TablePartitions, i=1)
    i > tp.npartitions && return nothing
    tp.npartitions == 1 && return tp.table, i + 1
    cols = columns(tp.table)
    newcols = AbstractVector[cols[j].arrays[i] for j = 1:length(cols)]
    nms = names(tp.table)
    tbl = Table(
        nms,
        types(tp.table),
        newcols,
        Dict{Symbol,AbstractVector}(nms[i] => newcols[i] for i = 1:length(nms)),
        schema(tp.table),
    )
    return tbl, i + 1
end

Tables.partitions(t::Table) = TablePartitions(t)

# high-level user API functions
Table(input, pos::Integer=1, len=nothing; kw...) =
    Table([ArrowBlob(tobytes(input), pos, len)]; kw...)
Table(input::Vector{UInt8}, pos::Integer=1, len=nothing; kw...) =
    Table([ArrowBlob(tobytes(input), pos, len)]; kw...)
Table(inputs::Vector; kw...) =
    Table([ArrowBlob(tobytes(x), 1, nothing) for x in inputs]; kw...)

# will detect whether we're reading a Table from a file or stream
function Table(blobs::Vector{ArrowBlob}; convert::Bool=true)
    t = Table()
    sch = nothing
    dictencodingslockable = Lockable(Dict{Int64,DictEncoding}()) # dictionary id => DictEncoding
    dictencoded = Dict{Int64,Meta.Field}() # dictionary id => field
    # we'll grow/add a record batch set of columns as they're constructed
    # must be holding the lock while growing/adding
    # starts at 0-length because we don't know how many record batches there will be
    rb_cols = []
    rb_cols_lock = ReentrantLock()
    rbi = 1
    tasks = Task[]
    for blob in blobs
        for batch in BatchIterator(blob)
            # store custom_metadata of batch.msg?
            header = batch.msg.header
            if header isa Meta.Schema
                @debug "parsing schema message"
                # assert endianness?
                # store custom_metadata?
                if sch === nothing
                    for (i, field) in enumerate(header.fields)
                        push!(names(t), Symbol(field.name))
                        # recursively find any dictionaries for any fields
                        getdictionaries!(dictencoded, field)
                        @debug "parsed column from schema: field = $field"
                    end
                    sch = header
                    schema(t)[] = sch
                elseif sch != header
                    throw(
                        ArgumentError(
                            "mismatched schemas between different arrow batches: $sch != $header",
                        ),
                    )
                end
            elseif header isa Meta.DictionaryBatch
                id = header.id
                recordbatch = header.data
                @debug "parsing dictionary batch message: id = $id, compression = $(recordbatch.compression)"
                @lock dictencodingslockable begin
                    dictencodings = dictencodingslockable[]
                    if haskey(dictencodings, id) && header.isDelta
                        # delta
                        field = dictencoded[id]
                        values, _, _, _ = build(
                            field,
                            field.type,
                            batch,
                            recordbatch,
                            dictencodingslockable,
                            Int64(1),
                            Int64(1),
                            Int64(1),
                            convert,
                        )
                        dictencoding = dictencodings[id]
                        if typeof(dictencoding.data) <: ChainedVector
                            append!(dictencoding.data, values)
                        else
                            A = ChainedVector([dictencoding.data, values])
                            S =
                                field.dictionary.indexType === nothing ? Int32 :
                                juliaeltype(field, field.dictionary.indexType, false)
                            dictencodings[id] = DictEncoding{eltype(A),S,typeof(A)}(
                                id,
                                A,
                                field.dictionary.isOrdered,
                                values.metadata,
                            )
                        end
                        continue
                    end
                    # new dictencoding or replace
                    field = dictencoded[id]
                    values, _, _, _ = build(
                        field,
                        field.type,
                        batch,
                        recordbatch,
                        dictencodingslockable,
                        Int64(1),
                        Int64(1),
                        Int64(1),
                        convert,
                    )
                    A = values
                    S =
                        field.dictionary.indexType === nothing ? Int32 :
                        juliaeltype(field, field.dictionary.indexType, false)
                    dictencodings[id] = DictEncoding{eltype(A),S,typeof(A)}(
                        id,
                        A,
                        field.dictionary.isOrdered,
                        values.metadata,
                    )
                end # lock
                @debug "parsed dictionary batch message: id=$id, data=$values\n"
            elseif header isa Meta.RecordBatch
                @debug "parsing record batch message: compression = $(header.compression)"
                push!(
                    tasks,
                    collect_cols!(
                        rbi,
                        rb_cols_lock,
                        rb_cols,
                        sch,
                        batch,
                        dictencodingslockable,
                        convert,
                    ),
                )
                rbi += 1
            else
                throw(ArgumentError("unsupported arrow message type: $(typeof(header))"))
            end
        end
    end
    _waitall(tasks)
    lu = lookup(t)
    ty = types(t)
    # 158; some implementations may send 0 record batches
    # no more multithreading, so no need to take the lock now
    if length(rb_cols) == 0 && !isnothing(sch)
        for field in sch.fields
            T = juliaeltype(field, buildmetadata(field), convert)
            push!(columns(t), T[])
        end
    end
    if length(rb_cols) > 0
        foreach(x -> push!(columns(t), x), rb_cols[1])
    end
    if length(rb_cols) > 1
        foreach(enumerate(rb_cols[2])) do (i, x)
            columns(t)[i] = ChainedVector([columns(t)[i], x])
        end
        foreach(3:length(rb_cols)) do j
            foreach(enumerate(rb_cols[j])) do (i, x)
                append!(columns(t)[i], x)
            end
        end
    end
    for (nm, col) in zip(names(t), columns(t))
        lu[nm] = col
        push!(ty, eltype(col))
    end
    getfield(t, :metadata)[] = buildmetadata(sch)
    return t
end

function collect_cols!(
    rbi,
    rb_cols_lock,
    rb_cols,
    sch,
    batch,
    dictencodingslockable,
    convert,
)
    @wkspawn begin
        cols = collect(VectorIterator(sch, batch, dictencodingslockable, convert))
        @lock rb_cols_lock begin
            if length(rb_cols) < rbi
                resize!(rb_cols, rbi)
            end
            rb_cols[rbi] = cols
        end
    end
end

function getdictionaries!(dictencoded, field)
    d = field.dictionary
    if d !== nothing
        dictencoded[d.id] = field
    end
    if field.children !== nothing
        for child in field.children
            getdictionaries!(dictencoded, child)
        end
    end
    return
end

struct Batch
    msg::Meta.Message
    bytes::Vector{UInt8}
    pos::Int
    id::Int
end

function Base.iterate(x::BatchIterator, (pos, id)=(x.startpos, 0))
    @debug "checking for next arrow message: pos = $pos"
    if pos + 3 > length(x.bytes)
        @debug "not enough bytes left for another batch message"
        return nothing
    end
    if readbuffer(x.bytes, pos, UInt32) != CONTINUATION_INDICATOR_BYTES
        @debug "didn't find continuation byte to keep parsing messages: $(readbuffer(x.bytes, pos, UInt32))"
        return nothing
    end
    pos += 4
    if pos + 3 > length(x.bytes)
        @debug "not enough bytes left to read length of another batch message"
        return nothing
    end
    msglen = readbuffer(x.bytes, pos, Int32)
    if msglen == 0
        @debug "message has 0 length; terminating message parsing"
        return nothing
    end
    pos += 4
    if pos + msglen - 1 > length(x.bytes)
        @debug "not enough bytes left to read Meta.Message"
        return nothing
    end
    msg = FlatBuffers.getrootas(Meta.Message, x.bytes, pos - 1)
    pos += msglen
    # pos now points to message body
    @debug "parsing message: pos = $pos, msglen = $msglen, bodyLength = $(msg.bodyLength)"
    if pos + msg.bodyLength - 1 > length(x.bytes)
        @debug "not enough bytes left to read message body"
        return nothing
    end
    return Batch(msg, x.bytes, pos, id), (pos + msg.bodyLength, id + 1)
end

struct VectorIterator
    schema::Meta.Schema
    batch::Batch # batch.msg.header MUST BE RecordBatch
    dictencodings::Lockable{Dict{Int64,DictEncoding}}
    convert::Bool
end

buildmetadata(f::Union{Meta.Field,Meta.Schema}) = buildmetadata(f.custom_metadata)
buildmetadata(meta) = toidict(String(kv.key) => String(kv.value) for kv in meta)
buildmetadata(::Nothing) = nothing
buildmetadata(x::AbstractDict) = x

function Base.iterate(
    x::VectorIterator,
    (columnidx, nodeidx, bufferidx, varbufferidx)=(Int64(1), Int64(1), Int64(1), Int64(1)),
)
    columnidx > length(x.schema.fields) && return nothing
    field = x.schema.fields[columnidx]
    @debug "building top-level column: field = $(field), columnidx = $columnidx, nodeidx = $nodeidx, bufferidx = $bufferidx, varbufferidx = $varbufferidx"
    A, nodeidx, bufferidx, varbufferidx = build(
        field,
        x.batch,
        x.batch.msg.header,
        x.dictencodings,
        nodeidx,
        bufferidx,
        varbufferidx,
        x.convert,
    )
    @debug "built top-level column: A = $(typeof(A)), columnidx = $columnidx, nodeidx = $nodeidx, bufferidx = $bufferidx, varbufferidx = $varbufferidx"
    @debug A
    return A, (columnidx + 1, nodeidx, bufferidx, varbufferidx)
end

Base.length(x::VectorIterator) = length(x.schema.fields)

const ListTypes =
    Union{Meta.Utf8,Meta.LargeUtf8,Meta.Binary,Meta.LargeBinary,Meta.List,Meta.LargeList}
const LargeLists = Union{Meta.LargeUtf8,Meta.LargeBinary,Meta.LargeList,Meta.LargeListView}
const ViewTypes = Union{Meta.Utf8View,Meta.BinaryView,Meta.ListView,Meta.LargeListView}

function build(field::Meta.Field, batch, rb, de, nodeidx, bufferidx, varbufferidx, convert)
    d = field.dictionary
    if d !== nothing
        validity = buildbitmap(batch, rb, nodeidx, bufferidx)
        bufferidx += 1
        buffer = rb.buffers[bufferidx]
        S = d.indexType === nothing ? Int32 : juliaeltype(field, d.indexType, false)
        bytes, indices = reinterp(S, batch, buffer, rb.compression)
        @lock de begin
            encoding = de[][d.id]
            A = DictEncoded(
                bytes,
                validity,
                indices,
                encoding,
                buildmetadata(field.custom_metadata),
            )
        end
        nodeidx += 1
        bufferidx += 1
    else
        A, nodeidx, bufferidx, varbufferidx = build(
            field,
            field.type,
            batch,
            rb,
            de,
            nodeidx,
            bufferidx,
            varbufferidx,
            convert,
        )
    end
    return A, nodeidx, bufferidx, varbufferidx
end

function buildbitmap(batch, rb, nodeidx, bufferidx)
    buffer = rb.buffers[bufferidx]
    voff = batch.pos + buffer.offset
    node = rb.nodes[nodeidx]
    if rb.compression === nothing
        return ValidityBitmap(batch.bytes, voff, node.length, node.null_count)
    else
        # compressed
        ptr = pointer(batch.bytes, voff)
        _, decodedbytes = uncompress(ptr, buffer, rb.compression)
        return ValidityBitmap(decodedbytes, 1, node.length, node.null_count)
    end
end

function uncompress(ptr::Ptr{UInt8}, buffer, compression)
    buffer.length == 0 && return 0, UInt8[]
    len = unsafe_load(convert(Ptr{Int64}, ptr))
    len == 0 && return 0, UInt8[]
    ptr += 8 # skip past uncompressed length as Int64
    encodedbytes = unsafe_wrap(Array, ptr, buffer.length - 8)
    if len == -1
        # len = -1 means data is not compressed
        # it's unclear why other language implementations allow this
        # but we support to be able to read data produced as such
        return length(encodedbytes), copy(encodedbytes)
    end
    decodedbytes = Vector{UInt8}(undef, len)
    if compression.codec === Meta.CompressionType.LZ4_FRAME
        comp = lz4_frame_decompressor()
        Base.@lock comp begin
            transcode(comp[], encodedbytes, decodedbytes)
        end
    elseif compression.codec === Meta.CompressionType.ZSTD
        comp = zstd_decompressor()
        Base.@lock comp begin
            transcode(comp[], encodedbytes, decodedbytes)
        end
    else
        error(
            "unsupported compression type when reading arrow buffers: $(typeof(compression.codec))",
        )
    end
    return len, decodedbytes
end

function reinterp(::Type{T}, batch, buf, compression) where {T}
    ptr = pointer(batch.bytes, batch.pos + buf.offset)
    bytes = batch.bytes
    len = buf.length
    if compression !== nothing
        len, bytes = uncompress(ptr, buf, compression)
        ptr = pointer(bytes)
    end
    # it would be technically more correct to check that T.layout->alignment > 8
    # but the datatype alignment isn't officially exported, so we're using
    # primitive types w/ sizeof(T) >= 16 as a proxy for types that need 16-byte alignment
    if sizeof(T) >= 16 && (UInt(ptr) & 15) != 0
        # https://github.com/apache/arrow-julia/issues/345
        # https://github.com/JuliaLang/julia/issues/42326
        # need to ensure that the data/pointers are aligned to 16 bytes
        # so we can't use unsafe_wrap here, but do an extra allocation
        # to avoid the allocation, user needs to ensure input buffer is
        # 16-byte aligned (somehow, it's not super straightforward how to ensure that)
        A = Vector{T}(undef, div(len, sizeof(T)))
        unsafe_copyto!(Ptr{UInt8}(pointer(A)), ptr, len)
        return bytes, A
    else
        return bytes, unsafe_wrap(Array, convert(Ptr{T}, ptr), div(len, sizeof(T)))
    end
end

const SubVector{T,P} = SubArray{T,1,P,Tuple{UnitRange{Int64}},true}

function build(
    f::Meta.Field,
    L::ListTypes,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    validity = buildbitmap(batch, rb, nodeidx, bufferidx)
    bufferidx += 1
    buffer = rb.buffers[bufferidx]
    ooff = batch.pos + buffer.offset
    OT = L isa LargeLists ? Int64 : Int32
    bytes, offs = reinterp(OT, batch, buffer, rb.compression)
    offsets = Offsets(bytes, offs)
    bufferidx += 1
    len = rb.nodes[nodeidx].length
    nodeidx += 1
    meta = buildmetadata(f.custom_metadata)
    T = juliaeltype(f, meta, convert)
    if L isa Meta.Utf8 ||
       L isa Meta.Utf8View ||
       L isa Meta.LargeUtf8 ||
       L isa Meta.Binary ||
       L isa Meta.BinaryView ||
       L isa Meta.LargeBinary
        buffer = rb.buffers[bufferidx]
        bytes, A = reinterp(UInt8, batch, buffer, rb.compression)
        bufferidx += 1
    else
        bytes = UInt8[]
        A, nodeidx, bufferidx, varbufferidx =
            build(f.children[1], batch, rb, de, nodeidx, bufferidx, varbufferidx, convert)
        # juliaeltype returns Vector for List, translate to SubArray
        S = Base.nonmissingtype(T)
        if S <: Vector
            ST = SubVector{eltype(A),typeof(A)}
            T = S == T ? ST : Union{Missing,ST}
        end
    end
    return List{T,OT,typeof(A)}(bytes, validity, offsets, A, len, meta),
    nodeidx,
    bufferidx,
    varbufferidx
end

function build(
    f::Meta.Field,
    L::ViewTypes,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    validity = buildbitmap(batch, rb, nodeidx, bufferidx)
    bufferidx += 1
    buffer = rb.buffers[bufferidx]
    _, views = reinterp(ViewElement, batch, buffer, rb.compression)
    inline = reinterpret(UInt8, views)  # reuse the (possibly realigned) memory backing `views`
    bufferidx += 1
    buffers = Vector{UInt8}[]
    for i = 1:rb.variadicBufferCounts[varbufferidx]
        buffer = rb.buffers[bufferidx]
        _, A = reinterp(UInt8, batch, buffer, rb.compression)
        push!(buffers, A)
        bufferidx += 1
    end
    varbufferidx += 1
    len = rb.nodes[nodeidx].length
    nodeidx += 1
    meta = buildmetadata(f.custom_metadata)
    T = juliaeltype(f, meta, convert)
    return View{T}(batch.bytes, validity, views, inline, buffers, len, meta),
    nodeidx,
    bufferidx,
    varbufferidx
end

function build(
    f::Meta.Field,
    L::Union{Meta.FixedSizeBinary,Meta.FixedSizeList},
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    validity = buildbitmap(batch, rb, nodeidx, bufferidx)
    bufferidx += 1
    len = rb.nodes[nodeidx].length
    nodeidx += 1
    if L isa Meta.FixedSizeBinary
        buffer = rb.buffers[bufferidx]
        bytes, A = reinterp(UInt8, batch, buffer, rb.compression)
        bufferidx += 1
    else
        bytes = UInt8[]
        A, nodeidx, bufferidx, varbufferidx =
            build(f.children[1], batch, rb, de, nodeidx, bufferidx, varbufferidx, convert)
    end
    meta = buildmetadata(f.custom_metadata)
    T = juliaeltype(f, meta, convert)
    return FixedSizeList{T,typeof(A)}(bytes, validity, A, len, meta),
    nodeidx,
    bufferidx,
    varbufferidx
end

function build(
    f::Meta.Field,
    L::Meta.Map,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    validity = buildbitmap(batch, rb, nodeidx, bufferidx)
    bufferidx += 1
    buffer = rb.buffers[bufferidx]
    ooff = batch.pos + buffer.offset
    OT = Int32
    bytes, offs = reinterp(OT, batch, buffer, rb.compression)
    offsets = Offsets(bytes, offs)
    bufferidx += 1
    len = rb.nodes[nodeidx].length
    nodeidx += 1
    A, nodeidx, bufferidx, varbufferidx =
        build(f.children[1], batch, rb, de, nodeidx, bufferidx, varbufferidx, convert)
    meta = buildmetadata(f.custom_metadata)
    T = juliaeltype(f, meta, convert)
    return Map{T,OT,typeof(A)}(validity, offsets, A, len, meta),
    nodeidx,
    bufferidx,
    varbufferidx
end

function build(
    f::Meta.Field,
    L::Meta.Struct,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    validity = buildbitmap(batch, rb, nodeidx, bufferidx)
    bufferidx += 1
    len = rb.nodes[nodeidx].length
    vecs = []
    nodeidx += 1
    for child in f.children
        A, nodeidx, bufferidx, varbufferidx =
            build(child, batch, rb, de, nodeidx, bufferidx, varbufferidx, convert)
        push!(vecs, A)
    end
    data = Tuple(vecs)
    meta = buildmetadata(f.custom_metadata)
    T = juliaeltype(f, meta, convert)
    fnames = ntuple(i -> Symbol(f.children[i].name), length(f.children))
    return Struct{T,typeof(data),fnames}(validity, data, len, meta),
    nodeidx,
    bufferidx,
    varbufferidx
end

function build(
    f::Meta.Field,
    L::Meta.Union,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    buffer = rb.buffers[bufferidx]
    bytes, typeIds = reinterp(UInt8, batch, buffer, rb.compression)
    bufferidx += 1
    if L.mode == Meta.UnionMode.Dense
        buffer = rb.buffers[bufferidx]
        bytes2, offsets = reinterp(Int32, batch, buffer, rb.compression)
        bufferidx += 1
    end
    vecs = []
    nodeidx += 1
    for child in f.children
        A, nodeidx, bufferidx, varbufferidx =
            build(child, batch, rb, de, nodeidx, bufferidx, varbufferidx, convert)
        push!(vecs, A)
    end
    data = Tuple(vecs)
    meta = buildmetadata(f.custom_metadata)
    T = juliaeltype(f, meta, convert)
    UT = UnionT(f, convert)
    if L.mode == Meta.UnionMode.Dense
        B = DenseUnion{T,UT,typeof(data)}(bytes, bytes2, typeIds, offsets, data, meta)
    else
        B = SparseUnion{T,UT,typeof(data)}(bytes, typeIds, data, meta)
    end
    return B, nodeidx, bufferidx, varbufferidx
end

function build(
    f::Meta.Field,
    L::Meta.Null,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    meta = buildmetadata(f.custom_metadata)
    T = juliaeltype(f, meta, convert)
    return NullVector{maybemissing(T)}(MissingVector(rb.nodes[nodeidx].length), meta),
    nodeidx + 1,
    bufferidx,
    varbufferidx
end

# primitives
function build(
    f::Meta.Field,
    ::L,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
) where {L}
    @debug "building array: L = $L"
    validity = buildbitmap(batch, rb, nodeidx, bufferidx)
    bufferidx += 1
    buffer = rb.buffers[bufferidx]
    meta = buildmetadata(f.custom_metadata)
    # get storage type (non-converted)
    T = juliaeltype(f, nothing, false)
    @debug "storage type for primitive: T = $T"
    bytes, A = reinterp(Base.nonmissingtype(T), batch, buffer, rb.compression)
    len = rb.nodes[nodeidx].length
    T = juliaeltype(f, meta, convert)
    @debug "final julia type for primitive: T = $T"
    return Primitive(T, bytes, validity, A, len, meta),
    nodeidx + 1,
    bufferidx + 1,
    varbufferidx
end

function build(
    f::Meta.Field,
    L::Meta.Bool,
    batch,
    rb,
    de,
    nodeidx,
    bufferidx,
    varbufferidx,
    convert,
)
    @debug "building array: L = $L"
    validity = buildbitmap(batch, rb, nodeidx, bufferidx)
    bufferidx += 1
    buffer = rb.buffers[bufferidx]
    meta = buildmetadata(f.custom_metadata)
    # get storage type (non-converted)
    T = juliaeltype(f, nothing, false)
    @debug "storage type for primitive: T = $T"
    buffer = rb.buffers[bufferidx]
    voff = batch.pos + buffer.offset
    node = rb.nodes[nodeidx]
    if rb.compression === nothing
        decodedbytes = batch.bytes
        pos = voff
        # return ValidityBitmap(batch.bytes, voff, node.length, node.null_count)
    else
        # compressed
        ptr = pointer(batch.bytes, voff)
        _, decodedbytes = uncompress(ptr, buffer, rb.compression)
        pos = 1
        # return ValidityBitmap(decodedbytes, 1, node.length, node.null_count)
    end
    len = rb.nodes[nodeidx].length
    T = juliaeltype(f, meta, convert)
    return BoolVector{T}(decodedbytes, pos, validity, len, meta),
    nodeidx + 1,
    bufferidx + 1,
    varbufferidx
end

# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

testtables = [
    (
        "basic",
        (col1=Int64[1, 2, 3, 4, 5, 6, 7, 8, 9, 10],),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    (
        "missing values",
        (col1=Union{Int64,Missing}[1, 2, 3, 4, 5, 6, 7, 8, 9, missing],),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    (
        "primitive types",
        (
            col1=[missing, missing, missing, missing],
            col2=Union{UInt8,Missing}[0, 1, 2, missing],
            col3=Union{UInt16,Missing}[0, 1, 2, missing],
            col4=Union{UInt32,Missing}[0, 1, 2, missing],
            col5=Union{UInt64,Missing}[0, 1, 2, missing],
            col6=Union{Int8,Missing}[0, 1, 2, missing],
            col7=Union{Int16,Missing}[0, 1, 2, missing],
            col8=Union{Int32,Missing}[0, 1, 2, missing],
            col9=Union{Int64,Missing}[0, 1, 2, missing],
            col10=Union{Float16,Missing}[0, 1, 2, missing],
            col11=Union{Float32,Missing}[0, 1, 2, missing],
            col12=Union{Float64,Missing}[0, 1, 2, missing],
            col13=[true, false, true, missing],
        ),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    (
        "arrow date/time types",
        (
            col14=[
                zero(Arrow.Decimal{Int32(2),Int32(2),Int128}),
                zero(Arrow.Decimal{Int32(2),Int32(2),Int128}),
                zero(Arrow.Decimal{Int32(2),Int32(2),Int128}),
                missing,
            ],
            col15=[
                zero(Arrow.Date{Arrow.Meta.DateUnit.DAY,Int32}),
                zero(Arrow.Date{Arrow.Meta.DateUnit.DAY,Int32}),
                zero(Arrow.Date{Arrow.Meta.DateUnit.DAY,Int32}),
                missing,
            ],
            col16=[
                zero(Arrow.Time{Arrow.Meta.TimeUnit.SECOND,Int32}),
                zero(Arrow.Time{Arrow.Meta.TimeUnit.SECOND,Int32}),
                zero(Arrow.Time{Arrow.Meta.TimeUnit.SECOND,Int32}),
                missing,
            ],
            col17=[
                zero(Arrow.Timestamp{Arrow.Meta.TimeUnit.SECOND,nothing}),
                zero(Arrow.Timestamp{Arrow.Meta.TimeUnit.SECOND,nothing}),
                zero(Arrow.Timestamp{Arrow.Meta.TimeUnit.SECOND,nothing}),
                missing,
            ],
            col18=[
                zero(Arrow.Interval{Arrow.Meta.IntervalUnit.YEAR_MONTH,Int32}),
                zero(Arrow.Interval{Arrow.Meta.IntervalUnit.YEAR_MONTH,Int32}),
                zero(Arrow.Interval{Arrow.Meta.IntervalUnit.YEAR_MONTH,Int32}),
                missing,
            ],
            col19=[
                zero(Arrow.Duration{Arrow.Meta.TimeUnit.SECOND}),
                zero(Arrow.Duration{Arrow.Meta.TimeUnit.SECOND}),
                zero(Arrow.Duration{Arrow.Meta.TimeUnit.SECOND}),
                missing,
            ],
            col20=[
                zero(Arrow.Date{Arrow.Meta.DateUnit.MILLISECOND,Int64}),
                zero(Arrow.Date{Arrow.Meta.DateUnit.MILLISECOND,Int64}),
                zero(Arrow.Date{Arrow.Meta.DateUnit.MILLISECOND,Int64}),
                missing,
            ],
        ),
        NamedTuple(),
        (convert=false,),
        nothing,
    ),
    (
        "list types",
        (
            col1=Union{String,Missing}["hey", "there", "sailor", missing],
            col2=Union{Vector{UInt8},Missing}[b"hey", b"there", b"sailor", missing],
            col3=Union{Vector{Int64},Missing}[Int64[1], Int64[2], Int64[3], missing],
            col4=Union{NTuple{2,Vector{Int64}},Missing}[
                (Int64[1], Int64[2]),
                missing,
                missing,
                (Int64[3], Int64[4]),
            ],
            col5=Union{NTuple{2,UInt8},Missing}[
                (0x01, 0x02),
                (0x03, 0x04),
                missing,
                (0x05, 0x06),
            ],
            col6=NamedTuple{(:a, :b),Tuple{Int64,String}}[
                (a=Int64(1), b="hey"),
                (a=Int64(2), b="there"),
                (a=Int64(3), b="sailor"),
                (a=Int64(4), b="jo-bob"),
            ],
        ),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    ("empty list types", (col1=[[]], col2=[()]), NamedTuple(), NamedTuple(), nothing),
    (
        "unions",
        (
            col1=Arrow.DenseUnionVector(
                Union{Int64,Float64,Missing}[1, 2.0, 3, 4.0, missing],
            ),
            col2=Arrow.SparseUnionVector(
                Union{Int64,Float64,Missing}[1, 2.0, 3, 4.0, missing],
            ),
        ),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    (
        "dict encodings",
        (col1=Arrow.DictEncode(Int64[4, 5, 6]),),
        NamedTuple(),
        NamedTuple(),
        function (tt)
            col1 = copy(tt.col1)
            @test typeof(col1) == PooledVector{Int64,Int8,Vector{Int8}}
        end,
    ),
    (
        "more dict encodings",
        (
            col1=Arrow.DictEncode(
                NamedTuple{(:a, :b),Tuple{Int64,Union{String,Missing}}}[
                    (a=Int64(1), b=missing),
                    (a=Int64(1), b=missing),
                    (a=Int64(3), b="sailor"),
                    (a=Int64(4), b="jo-bob"),
                ],
            ),
        ),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    ("PooledArray", (col1=PooledArray([4, 5, 6, 6]),), NamedTuple(), NamedTuple(), nothing),
    (
        "auto-converting types",
        (
            col1=[Date(2001, 1, 2), Date(2010, 10, 10), Date(2020, 12, 1)],
            col2=[Time(1, 1, 2), Time(13, 10, 10), Time(22, 12, 1)],
            col3=[DateTime(2001, 1, 2), DateTime(2010, 10, 10), DateTime(2020, 12, 1)],
            col4=[
                ZonedDateTime(2001, 1, 2, TimeZone("America/Denver")),
                ZonedDateTime(2010, 10, 10, TimeZone("America/Denver")),
                ZonedDateTime(2020, 12, 1, TimeZone("America/Denver")),
            ],
        ),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    (
        "Map",
        (col1=[Dict(Int32(1) => Float32(3.14)), missing],),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    (
        "non-standard types",
        (
            col1=[:hey, :there, :sailor],
            col2=['a', 'b', 'c'],
            col3=Arrow.DictEncode(['a', 'a', 'b']),
            col4=[
                UUID("48075322-8645-4ac6-b590-c9f46068565a"),
                UUID("99c7d976-ccfd-45b9-9793-51008607c638"),
                UUID("f96d9974-5a7b-47e3-bbc0-d680d11490d4"),
            ],
        ),
        NamedTuple(),
        NamedTuple(),
        nothing,
    ),
    (
        "large lists",
        (
            col1=Union{String,Missing}["hey", "there", "sailor", missing],
            col2=Union{Vector{UInt8},Missing}[b"hey", b"there", b"sailor", missing],
            col3=Union{Vector{Int64},Missing}[Int64[1], Int64[2], Int64[3], missing],
            col4=Union{NTuple{2,Vector{Int64}},Missing}[
                (Int64[1], Int64[2]),
                missing,
                missing,
                (Int64[3], Int64[4]),
            ],
            col5=Union{NTuple{2,UInt8},Missing}[
                (0x01, 0x02),
                (0x03, 0x04),
                missing,
                (0x05, 0x06),
            ],
            col6=NamedTuple{(:a, :b),Tuple{Int64,String}}[
                (a=Int64(1), b="hey"),
                (a=Int64(2), b="there"),
                (a=Int64(3), b="sailor"),
                (a=Int64(4), b="jo-bob"),
            ],
        ),
        (largelists=true,),
        NamedTuple(),
        nothing,
    ),
    (
        "dictencode keyword",
        (
            col1=Int64[1, 2, 3, 4],
            col2=Union{String,Missing}["hey", "there", "sailor", missing],
            col3=Arrow.DictEncode(
                NamedTuple{(:a, :b),Tuple{Int64,Union{String,Missing}}}[
                    (a=Int64(1), b=missing),
                    (a=Int64(1), b=missing),
                    (a=Int64(3), b="sailor"),
                    (a=Int64(4), b="jo-bob"),
                ],
            ),
            col4=[:a, :b, :c, missing],
            col5=[Date(2020, 1, 1) for x = 1:4],
        ),
        (dictencode=true,),
        NamedTuple(),
        nothing,
    ),
    (
        "nesteddictencode keyword",
        (
            col1=NamedTuple{
                (:a, :b),
                Tuple{Int64,Union{Missing,NamedTuple{(:c,),Tuple{String}}}},
            }[
                (a=Int64(1), b=missing),
                (a=Int64(1), b=missing),
                (a=Int64(3), b=(c="sailor",)),
                (a=Int64(4), b=(c="jo-bob",)),
            ],
        ),
        (dictencode=true, dictencodenested=true),
        NamedTuple(),
        nothing,
    ),
    (
        "Julia unions",
        (
            col1=Union{Int,String}[1, "hey", 2, "ho"],
            col2=Union{Char,NamedTuple{(:a,),Tuple{Symbol}}}['a', (a=:hey,), 'b', (a=:ho,)],
        ),
        (denseunions=false,),
        NamedTuple(),
        nothing,
    ),
    (
        "Decimal256",
        (
            col1=[
                zero(Arrow.Decimal{Int32(2),Int32(2),Arrow.Int256}),
                zero(Arrow.Decimal{Int32(2),Int32(2),Arrow.Int256}),
                zero(Arrow.Decimal{Int32(2),Int32(2),Arrow.Int256}),
                missing,
            ],
        ),
        NamedTuple(),
        (convert=false,),
        nothing,
    ),
];

function testtable(nm, t, writekw, readkw, extratests)
    @testset "testing: $nm" begin
        io = Arrow.tobuffer(t; writekw...)
        tt = Arrow.Table(io; readkw...)
        @test length(tt) == length(t)
        @test all(isequal.(values(t), values(tt)))
        extratests !== nothing && extratests(tt)
        seekstart(io)
        str = Arrow.Stream(io; readkw...)
        tt = first(str)
        @test length(tt) == length(t)
        @test all(isequal.(values(t), values(tt)))
        # compressed
        io = Arrow.tobuffer(t; compress=((:lz4, :zstd)[rand(1:2)]), writekw...)
        tt = Arrow.Table(io; readkw...)
        @test length(tt) == length(t)
        @test all(isequal.(values(t), values(tt)))
        extratests !== nothing && extratests(tt)
        seekstart(io)
        str = Arrow.Stream(io; readkw...)
        tt = first(str)
        @test length(tt) == length(t)
        @test all(isequal.(values(t), values(tt)))
        # file
        io = Arrow.tobuffer(t; file=true, writekw...)
        tt = Arrow.Table(io; readkw...)
        @test length(tt) == length(t)
        @test all(isequal.(values(t), values(tt)))
        extratests !== nothing && extratests(tt)
        seekstart(io)
        str = Arrow.Stream(io; readkw...)
        tt = first(str)
        @test length(tt) == length(t)
        @test all(isequal.(values(t), values(tt)))
    end
end

# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

function testappend(nm, t, writekw, readkw, extratests)
    @testset "append: $nm" begin
        io = Arrow.tobuffer(t; writekw...)
        bytes = read(io)
        mktemp() do path, io
            write(io, bytes)
            close(io)

            t1 = Arrow.Table(read(path); readkw...)
            f1 = first(Tables.columns(t1))
            Arrow.append(path, t1; writekw..., readkw...)
            nparts = 0
            for t2 in Arrow.Stream(path)
                @test isequal(f1, first(Tables.columns(t2)))
                nparts += 1
            end
            @test nparts == 2
        end
    end
end

function testappend_compression(compression_option)
    mktempdir() do path
        testdata = (col1=Int64[1, 2, 3, 4, 5, 6, 7, 8, 9, 10],)
        file1 = joinpath(path, "table1.arrow")
        file2 = joinpath(path, "table2.arrow")

        open(file1, "w") do io
            Arrow.write(io, testdata; file=false, compress=compression_option)
        end
        isstream, schema, compression = open(Arrow.stream_properties, file1)
        @test isstream
        @test compression == compression_option

        open(file2, "w") do io
            Arrow.write(io, testdata; file=false)
        end

        arrow_table2 = Arrow.Table(file2)
        arrow_table2 |> Arrow.append(file1)
        arrow_table1 = Arrow.Table(file1)

        isstream, schema, compression = open(Arrow.stream_properties, file1)
        @test isstream
        @test compression == compression_option

        @test length(Tables.columns(arrow_table1)[1]) == 20
        @test length(Tables.columns(arrow_table2)[1]) == 10
    end
end

function testappend_partitions()
    mktempdir() do path
        testdata = (col1=Int64[1, 2, 3, 4, 5, 6, 7, 8, 9, 10],)
        file1 = joinpath(path, "table1.arrow")
        file2 = joinpath(path, "table2.arrow")
        open(file1, "w") do io
            Arrow.write(io, testdata; file=false)
        end
        arrow_table1 = Arrow.Table(file1)
        isstream, schema, compression = open(Arrow.stream_properties, file1)
        @test isstream
        @test compression === nothing
        @test schema.names == (:col1,)
        @test schema.types == (Int64,)

        # can only append to arrow stream
        open(file2, "w") do io
            Arrow.write(io, testdata; file=true)
        end
        @test_throws ArgumentError Arrow.append(file2, arrow_table1)

        # can append to an empty file
        rm(file2)
        for _ = 1:5
            Arrow.append(file2, arrow_table1)
        end
        appended_table1 = Arrow.Table(file2)
        @test length(Tables.columns(appended_table1)[1]) == 50

        # schema must match
        testdata2 = (col2=Int64[1, 2, 3, 4, 5, 6, 7, 8, 9, 10],)
        open(file2, "w") do io
            Arrow.write(io, testdata2; file=false)
        end
        @test_throws ArgumentError Arrow.append(file2, arrow_table1)

        # recreate file2 in arrow format with correct schema
        open(file2, "w") do io
            Arrow.write(io, testdata; file=false)
        end

        # start
        # arrow_table1: 1 partition, 10 rows
        # arrow_table2: 1 partition, 10 rows
        arrow_table2 = Arrow.Table(file2)
        @test length(Tables.columns(arrow_table1)[1]) == 10
        @test length(Tables.columns(arrow_table2)[1]) == 10

        @test_throws ArgumentError Arrow.append(file1, arrow_table2; ntasks=-1)
        arrow_table2 |> Arrow.append(file1)
        arrow_table1 = Arrow.Table(file1)
        # now
        # arrow_table1: 2 partitions, 20 rows
        # arrow_table2: 1 partition, 10 rows

        @test Tables.schema(arrow_table1) == Tables.schema(arrow_table2)
        @test length(Tables.columns(arrow_table1)[1]) == 20
        @test length(Tables.columns(arrow_table2)[1]) == 10
        @test length(collect(Tables.partitions(Arrow.Stream(file1)))) ==
              2 * length(collect(Tables.partitions(Arrow.Stream(file2))))

        Arrow.append(file2, arrow_table1; ntasks=1) # append with single task
        arrow_table2 = Arrow.Table(file2)
        # now
        # arrow_table1: 2 partitions, 20 rows
        # arrow_table2: 2 partitions, 30 rows (both partitions of table1 are appended as separate partitions)

        @test Tables.schema(arrow_table1) == Tables.schema(arrow_table2)
        @test length(Tables.columns(arrow_table1)[1]) == 20
        @test length(Tables.columns(arrow_table2)[1]) == 30
        @test length(collect(Tables.partitions(Arrow.Stream(file1)))) == 2
        @test length(collect(Tables.partitions(Arrow.Stream(file2)))) == 3

        Arrow.append(file1, Arrow.Stream(file2))
        arrow_table1 = Arrow.Table(file1)
        # now
        # arrow_table1: 4 partitions, 50 rows (partitions of file2 stream are appended without being merged)
        # arrow_table2: 2 partitions, 30 rows

        @test Tables.schema(arrow_table1) == Tables.schema(arrow_table2)
        @test length(Tables.columns(arrow_table1)[1]) == 50
        @test length(Tables.columns(arrow_table2)[1]) == 30
        @test length(collect(Tables.partitions(Arrow.Stream(file1)))) == 5
        @test length(collect(Tables.partitions(Arrow.Stream(file2)))) == 3
    end
end

# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

struct ViewElement
    length::Int32
    prefix::Int32
    bufindex::Int32
    offset::Int32
end

"""
    Arrow.View

An `ArrowVector` where each element is a variable sized list of some kind, like an `AbstractVector` or `AbstractString`.
"""
struct View{T} <: ArrowVector{T}
    arrow::Vector{UInt8} # need to hold a reference to arrow memory blob
    validity::ValidityBitmap
    data::Vector{ViewElement}
    inline::Vector{UInt8} # `data` field reinterpreted as a byte array
    buffers::Vector{Vector{UInt8}} # holds non-inlined data
    ℓ::Int
    metadata::Union{Nothing,Base.ImmutableDict{String,String}}
end

Base.size(l::View) = (l.ℓ,)

@propagate_inbounds function Base.getindex(l::View{T}, i::Integer) where {T}
    @boundscheck checkbounds(l, i)
    @inbounds v = l.data[i]
    S = Base.nonmissingtype(T)
    if S <: Base.CodeUnits
        # BinaryView
        return !l.validity[i] ? missing :
               v.length < 13 ?
               Base.CodeUnits(
            StringView(
                @view l.inline[(((i - 1) * 16) + 5):(((i - 1) * 16) + 5 + v.length - 1)]
            ),
        ) :
               Base.CodeUnits(
            StringView(
                @view l.buffers[v.bufindex + 1][(v.offset + 1):(v.offset + v.length)]
            ),
        )
    else
        # Utf8View
        return !l.validity[i] ? missing :
               v.length < 13 ?
               ArrowTypes.fromarrow(
            T,
            StringView(
                @view l.inline[(((i - 1) * 16) + 5):(((i - 1) * 16) + 5 + v.length - 1)]
            ),
        ) :
               ArrowTypes.fromarrow(
            T,
            StringView(
                @view l.buffers[v.bufindex + 1][(v.offset + 1):(v.offset + v.length)]
            ),
        )
    end
end

# @propagate_inbounds function Base.setindex!(l::List{T}, v, i::Integer) where {T}

# end

#!/bin/bash
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

set -eu

SOURCE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
SOURCE_TOP_DIR="$(cd "${SOURCE_DIR}/../../" && pwd)"

if [ "$#" -ne 1 ]; then
  echo "Usage: $0 <rc>"
  echo " e.g.: $0 1"
  exit 1
fi

rc=$1

: ${RELEASE_DEFAULT:=1}
: ${RELEASE_CLEANUP:=${RELEASE_DEFAULT}}
: ${RELEASE_PULL:=${RELEASE_DEFAULT}}
: ${RELEASE_PUSH_TAG:=${RELEASE_DEFAULT}}
: ${RELEASE_SIGN:=${RELEASE_DEFAULT}}
: ${RELEASE_UPLOAD:=${RELEASE_DEFAULT}}

cd "${SOURCE_TOP_DIR}"

if [ ${RELEASE_PULL} -gt 0 -o ${RELEASE_PUSH_TAG} -gt 0 ]; then
  git_origin_url="$(git remote get-url origin)"
  if [ "${git_origin_url}" != "git@github.com:apache/arrow-julia.git" ]; then
    echo "This script must be ran with working copy of apache/arrow-julia."
    echo "The origin's URL: ${git_origin_url}"
    exit 1
  fi
fi

if [ ${RELEASE_PULL} -gt 0 ]; then
  echo "Ensure using the latest commit"
  git checkout main
  git pull --rebase --prune
fi

version=$(grep -o '^version = ".*"' "Project.toml" | \
            sed -e 's/^version = "//' \
                -e 's/"$//')

rc_tag="v${version}-rc${rc}"
echo "Tagging for RC: ${rc_tag}"
git tag -a -m "${version} RC${rc}" "${rc_tag}"
if [ ${RELEASE_PUSH_TAG} -gt 0 ]; then
  git push origin "${rc_tag}"
fi

rc_hash="$(git rev-list --max-count=1 "${rc_tag}")"

id="apache-arrow-julia-${version}"
rc_id="${id}-rc${rc}"
dev_dist_url="https://dist.apache.org/repos/dist/dev/arrow"
dev_dist_dir="dev/release/dist"
tar_gz="${id}.tar.gz"
tar_gz_path="${dev_dist_dir}/${rc_id}/${tar_gz}"
rc_url="${dev_dist_url}/${rc_id}/"

echo "Checking out ${dev_dist_url}"
rm -rf "${dev_dist_dir}"
svn co --depth=empty "${dev_dist_url}" "${dev_dist_dir}"

echo "Attempting to create ${tar_gz} from tag ${rc_tag}"
mkdir -p "$(dirname "${tar_gz_path}")"
git archive "${rc_hash}" --prefix "${id}/" --output "${tar_gz_path}"

pushd "${dev_dist_dir}/${rc_id}"

echo "Running Rat license checker on ${tar_gz}"
../../run_rat.sh ${tar_gz}

if [ ${RELEASE_SIGN} -gt 0 ]; then
  echo "Signing tar.gz and creating checksums"
  gpg --armor --output ${tar_gz}.asc --detach-sig ${tar_gz}
fi

if type shasum >/dev/null 2>&1; then
  sha256_generate="shasum -a 256"
  sha512_generate="shasum -a 512"
else
  sha256_generate="sha256sum"
  sha512_generate="sha512sum"
fi
${sha256_generate} ${tar_gz} > ${tar_gz}.sha256
${sha512_generate} ${tar_gz} > ${tar_gz}.sha512

if [ ${RELEASE_UPLOAD} -gt 0 ]; then
  echo "Uploading to ${rc_url}"
  svn add .
  svn ci -m "Apache Arrow Julia ${version} ${rc}"
fi

popd

if [ ${RELEASE_CLEANUP} -gt 0 ]; then
  echo "Removing temporary directory"
  rm -rf "${dev_dist_dir}"
fi

echo "Draft email for dev@arrow.apache.org mailing list"
echo ""
echo "---------------------------------------------------------"
cat <<MAIL
To: dev@arrow.apache.org
Subject: [VOTE][Julia] Release Apache Arrow Julia ${version} RC${rc}

Hi,

I would like to propose the following release candidate (RC${rc}) of
Apache Arrow Julia version ${version}.

This release candidate is based on commit:
${rc_hash} [1]

The source release rc${rc} is hosted at [2].

Please download, verify checksums and signatures, run the unit tests,
and vote on the release. See [3] for how to validate a release candidate.

The vote will be open for at least 24 hours.

[ ] +1 Release this as Apache Arrow Julia ${version}
[ ] +0
[ ] -1 Do not release this as Apache Arrow Julia ${version} because...

[1]: https://github.com/apache/arrow-julia/tree/${rc_hash}
[2]: ${rc_url}
[3]: https://github.com/apache/arrow-julia/blob/main/dev/release/README.md#verify
MAIL
echo "---------------------------------------------------------"

#!/bin/bash
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

set -eu

SOURCE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
TOP_SOURCE_DIR="$(dirname $(dirname ${SOURCE_DIR}))"

if [ "$#" -ne 2 ]; then
  echo "Usage: $0 <version> <rc>"
  echo " e.g.: $0 2.2.1 1"
  exit 1
fi

set -o pipefail
set -x

VERSION="$1"
RC="$2"

ARROW_DIST_URL="https://dist.apache.org/repos/dist/dev/arrow"
ARCHIVE_BASE_NAME="apache-arrow-julia-${VERSION}"

: ${VERIFY_DEFAULT:=1}
: ${VERIFY_DOWNLOAD:=${VERIFY_DEFAULT}}
: ${VERIFY_FORCE_USE_JULIA_BINARY:=0}
: ${VERIFY_SIGN:=${VERIFY_DEFAULT}}

download_dist_file() {
  curl \
    --fail \
    --location \
    --remote-name \
    --show-error \
    --silent \
    "${ARROW_DIST_URL}/$1"
}

download_rc_file() {
  local path="apache-arrow-julia-${VERSION}-rc${RC}/$1"
  if [ ${VERIFY_DOWNLOAD} -gt 0 ]; then
    download_dist_file "${path}"
  else
    cp "${SOURCE_DIR}/dist/${path}" "$1"
  fi
}

import_gpg_keys() {
  if [ ${VERIFY_SIGN} -gt 0 ]; then
    download_dist_file KEYS
    gpg --import KEYS
  fi
}

if type shasum >/dev/null 2>&1; then
  sha256_verify="shasum -a 256 -c"
  sha512_verify="shasum -a 512 -c"
else
  sha256_verify="sha256sum -c"
  sha512_verify="sha512sum -c"
fi

fetch_archive() {
  download_rc_file ${ARCHIVE_BASE_NAME}.tar.gz
  if [ ${VERIFY_SIGN} -gt 0 ]; then
    download_rc_file ${ARCHIVE_BASE_NAME}.tar.gz.asc
    gpg --verify ${ARCHIVE_BASE_NAME}.tar.gz.asc ${ARCHIVE_BASE_NAME}.tar.gz
  fi
  download_rc_file ${ARCHIVE_BASE_NAME}.tar.gz.sha256
  ${sha256_verify} ${ARCHIVE_BASE_NAME}.tar.gz.sha256
  download_rc_file ${ARCHIVE_BASE_NAME}.tar.gz.sha512
  ${sha512_verify} ${ARCHIVE_BASE_NAME}.tar.gz.sha512
}

setup_tmpdir() {
  cleanup() {
    if [ "${VERIFY_SUCCESS}" = "yes" ]; then
      rm -rf "${VERIFY_TMPDIR}"
    else
      echo "Failed to verify release candidate. See ${VERIFY_TMPDIR} for details."
    fi
  }

  if [ -z "${VERIFY_TMPDIR:-}" ]; then
    VERIFY_TMPDIR=$(mktemp -d -t "$1.XXXXX")
    trap cleanup EXIT
  else
    mkdir -p "${VERIFY_TMPDIR}"
  fi
}

latest_julia_version() {
  curl \
    --fail \
    --location \
    --show-error \
    --silent \
    https://api.github.com/repos/JuliaLang/julia/releases/latest | \
    grep -o '"tag_name": "v.*"' | \
    head -n 1 | \
    sed -e 's/^"tag_name": "v//g' \
        -e 's/"$//g'
}

ensure_julia() {
  if [ ${VERIFY_FORCE_USE_JULIA_BINARY} -le 0 ]; then
    if julia --version; then
      return
    fi
  fi

  local julia_binary_url=https://julialang-s3.julialang.org/bin
  local julia_version=$(latest_julia_version)
  local julia_version_series=${julia_version%.*}
  case "$(uname)" in
    Darwin)
      julia_binary_url+="/mac"
      case "$(arch)" in
        arm64)
          julia_binary_url+="/aarch64"
          julia_binary_url+="/${julia_version_series}"
          julia_binary_url+="/julia-${julia_version}-macaarch64.tar.gz"
          ;;
        i386)
          julia_binary_url+="/x64"
          julia_binary_url+="/${julia_version_series}"
          julia_binary_url+="/julia-${julia_version}-mac64.tar.gz"
          ;;
        *)
          echo "You must install Julia manually on $(uname) $(arch)"
          ;;
      esac
      ;;
    Linux)
      julia_binary_url+="/linux"
      case "$(arch)" in
        aarch64)
          julia_binary_url+="/aarch64"
          ;;
        x86_64)
          julia_binary_url+="/x64"
          ;;
        *)
          echo "You must install Julia manually on $(uname) $(arch)"
          ;;
      esac
      julia_binary_url+="/${julia_version_series}"
      julia_binary_url+="/julia-${julia_version}-linux-$(arch).tar.gz"
      ;;
    *)
      echo "You must install Julia manually on $(uname)"
      exit 1
      ;;
  esac
  julia_binary_tar_gz=$(basename ${julia_binary_url})
  curl \
    --fail \
    --location \
    --output ${julia_binary_tar_gz} \
    --show-error \
    --silent \
    ${julia_binary_url}
  tar xf ${julia_binary_tar_gz}
  julia_path=$(echo julia-*/bin/julia)
  PATH="$(pwd)/$(dirname ${julia_path}):${PATH}"
  export JULIA_DEPOT_PATH="$(pwd)/.julia"
}

test_source_distribution() {
  pushd src/ArrowTypes
  julia --project -e 'import Pkg; Pkg.build(); Pkg.test()'
  popd
  julia --project -e 'import Pkg; Pkg.build(); Pkg.test()'
}

VERIFY_SUCCESS=no

setup_tmpdir "arrow-julia-${VERSION}-${RC}"
echo "Working in sandbox ${VERIFY_TMPDIR}"
cd "${VERIFY_TMPDIR}"

import_gpg_keys
fetch_archive
tar xf ${ARCHIVE_BASE_NAME}.tar.gz
ensure_julia
pushd ${ARCHIVE_BASE_NAME}
test_source_distribution
popd

VERIFY_SUCCESS=yes
echo "RC looks good!"

#!/bin/bash
#
# Licensed to the Apache Software Foundation (ASF) under one
# or more contributor license agreements.  See the NOTICE file
# distributed with this work for additional information
# regarding copyright ownership.  The ASF licenses this file
# to you under the Apache License, Version 2.0 (the
# "License"); you may not use this file except in compliance
# with the License.  You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing,
# software distributed under the License is distributed on an
# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
# KIND, either express or implied.  See the License for the
# specific language governing permissions and limitations
# under the License.

set -eu

if [ "$#" -ne 2 ]; then
  echo "Usage: $0 <version> <rc>"
  echo " e.g.: $0 2.2.1 1"
  exit 1
fi

version=$1
rc=$2

rc_id="apache-arrow-julia-${version}-rc${rc}"
release_id="arrow-julia-${version}"
echo "Move from dev/ to release/"
svn \
  mv \
  -m "Apache Arrow Julia ${version}" \
  https://dist.apache.org/repos/dist/dev/arrow/${rc_id} \
  https://dist.apache.org/repos/dist/release/arrow/${release_id}

echo "Remove all RCs"
old_rcs=$(
  svn ls https://dist.apache.org/repos/dist/dev/arrow/ | \
  grep -E '^apache-arrow-julia-' | \
  sort --version-sort --reverse
)
for old_rc in $old_rcs; do
  echo "Remove RC ${old_rc}"
  svn \
    delete \
    -m "Remove old Apache Arrow Julia RC: ${old_rc}" \
    https://dist.apache.org/repos/dist/dev/arrow/${old_rc}
done

echo "Keep only the latest versions"
old_releases=$(
  svn ls https://dist.apache.org/repos/dist/release/arrow/ | \
  grep -E '^arrow-julia-' | \
  sort --version-sort --reverse | \
  tail -n +2
)
for old_release_version in $old_releases; do
  echo "Remove old release ${old_release_version}"
  svn \
    delete \
    -m "Remove old Apache Arrow Julia release: ${old_release_version}" \
    https://dist.apache.org/repos/dist/release/arrow/${old_release_version}
done

echo "Success! The release is available here:"
echo "  https://dist.apache.org/repos/dist/release/arrow/${release_id}"
echo
echo "Add this release to ASF's report database:"
echo "  https://reporter.apache.org/addrelease.html?arrow"
